#import "iCore.h"
#import "iPhone.h"
#import "iHUD.h"
#import "iStringUtils.h"
#import "iHttp.h"
#import "iJSON.h"
#import "iMedia.h"
@class b4i_main;
@class b4i_httputils2service;
@class _multipartfiledata;
@class b4i_speakbutton;
@interface b4i_httpjob : B4IClass
- (NSString*)  _class_globals;
@property (nonatomic)NSString* _jobname;
@property (nonatomic)BOOL _success;
@property (nonatomic)NSString* _username;
@property (nonatomic)NSString* _password;
@property (nonatomic)NSString* _errormessage;
@property (nonatomic)NSObject* _target;
@property (nonatomic)B4IHttpRequest* _req;
@property (nonatomic)NSObject* _tag;
@property (nonatomic)B4IHttpResponse* _res;
@property (nonatomic)b4i_main* _main;
@property (nonatomic)b4i_httputils2service* _httputils2service;
- (NSString*)  _complete:(B4IHttpResponse*) _res1;
- (NSString*)  _download:(NSString*) _link;
- (NSString*)  _download2:(NSString*) _link :(B4IArray*) _parameters;
- (B4IBitmap*)  _getbitmap;
- (B4IInputStream*)  _getinputstream;
- (B4IHttpRequest*)  _getrequest;
- (NSString*)  _getstring;
- (NSString*)  _getstring2:(NSString*) _encoding;
- (NSString*)  _initialize:(B4I*) _ba :(NSString*) _name :(NSObject*) _targetmodule;
- (NSString*)  _postbytes:(NSString*) _link :(B4IArray*) _data;
- (NSString*)  _postfile:(NSString*) _link :(NSString*) _dir :(NSString*) _filename;
- (NSString*)  _postmultipart:(NSString*) _link :(B4IMap*) _namevalues :(B4IList*) _files;
- (NSString*)  _poststring:(NSString*) _link :(NSString*) _text;
- (NSString*)  _release;
@end
@interface _multipartfiledata:NSObject
@property (nonatomic)BOOL IsInitialized;
@property (nonatomic)NSString* Dir;
@property (nonatomic)NSString* FileName;
@property (nonatomic)NSString* KeyName;
@property (nonatomic)NSString* ContentType;
-(void)Initialize;
@end
