
#import "b4i_httputils2service.h"
#import "b4i_main.h"
#import "b4i_httpjob.h"
#import "b4i_speakbutton.h"


@implementation b4i_httputils2service 


+ (instancetype)new {
    static b4i_httputils2service* shared = nil;
    if (shared == nil) {
        shared = [self alloc];
        shared.bi = [[B4I alloc] init:shared];
        shared.__c = [B4ICommon new];
    }
    return shared;
}

- (NSString*)  _completejob:(int) _taskid :(BOOL) _success :(NSString*) _errormessage :(B4IHttpResponse*) _res{
b4i_httpjob* _job = nil;
 //BA.debugLineNum = 34;BA.debugLine="Sub CompleteJob(TaskId As Int, success As Boolean,";
 //BA.debugLineNum = 35;BA.debugLine="Dim job As HttpJob = TaskIdToJob.Get(TaskId)";
_job = (b4i_httpjob*)([self._taskidtojob Get:(NSObject*)(@(_taskid))]);
 //BA.debugLineNum = 36;BA.debugLine="TaskIdToJob.Remove(TaskId)";
[self._taskidtojob Remove:(NSObject*)(@(_taskid))];
 //BA.debugLineNum = 37;BA.debugLine="job.success = success";
_job._success = _success;
 //BA.debugLineNum = 38;BA.debugLine="job.errorMessage = errorMessage";
_job._errormessage = _errormessage;
 //BA.debugLineNum = 39;BA.debugLine="job.Complete(res)";
[_job _complete:_res];
 //BA.debugLineNum = 40;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _hc_responseerror:(B4IHttpResponse*) _response :(NSString*) _reason :(int) _statuscode :(int) _taskid{
 //BA.debugLineNum = 24;BA.debugLine="Sub hc_ResponseError (Response As HttpResponse, Re";
 //BA.debugLineNum = 25;BA.debugLine="Log(\"Error response: \" & Response.GetString & \",";
[self.__c Log:[@[@"Error response: ",[_response GetString],@", status code: ",[self.bi NumberToString:@(_statuscode)]] componentsJoinedByString:@""]];
 //BA.debugLineNum = 26;BA.debugLine="CompleteJob(TaskId, False, Reason, Null)";
[self _completejob:_taskid :[self.__c False] :_reason :(B4IHttpResponse*)([self.__c Null])];
 //BA.debugLineNum = 27;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _hc_responsesuccess:(B4IHttpResponse*) _response :(int) _taskid{
 //BA.debugLineNum = 29;BA.debugLine="Sub hc_ResponseSuccess (Response As HttpResponse,";
 //BA.debugLineNum = 30;BA.debugLine="Log(\"response success\")";
[self.__c Log:@"response success"];
 //BA.debugLineNum = 31;BA.debugLine="CompleteJob(TaskId, True, \"\", Response)";
[self _completejob:_taskid :[self.__c True] :@"" :_response];
 //BA.debugLineNum = 32;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _initialize{
 //BA.debugLineNum = 9;BA.debugLine="Private Sub initialize";
 //BA.debugLineNum = 10;BA.debugLine="hc.initialize(\"hc\")";
[self._hc Initialize:self.bi :@"hc"];
 //BA.debugLineNum = 11;BA.debugLine="TaskIdToJob.initialize";
[self._taskidtojob Initialize];
 //BA.debugLineNum = 12;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _process_globals{
self._main=[b4i_main new];
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 3;BA.debugLine="Private hc As HttpClient";
self._hc = [B4IHttp new];
 //BA.debugLineNum = 4;BA.debugLine="Private TaskIdToJob As Map";
self._taskidtojob = [B4IMap new];
 //BA.debugLineNum = 5;BA.debugLine="Public TempFolder As String";
self._tempfolder = @"";
 //BA.debugLineNum = 6;BA.debugLine="Private taskCounter As Int";
self._taskcounter = 0;
 //BA.debugLineNum = 7;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _submitjob:(b4i_httpjob*) _job{
 //BA.debugLineNum = 13;BA.debugLine="Public Sub SubmitJob(job As HttpJob)";
 //BA.debugLineNum = 14;BA.debugLine="If hc.IsInitialized = False Then initialize";
if ([self._hc IsInitialized]==[self.__c False]) { 
[self _initialize];};
 //BA.debugLineNum = 15;BA.debugLine="taskCounter = taskCounter + 1";
self._taskcounter = (int) (self._taskcounter+1);
 //BA.debugLineNum = 16;BA.debugLine="TaskIdToJob.Put(taskCounter, job)";
[self._taskidtojob Put:(NSObject*)(@(self._taskcounter)) :(NSObject*)(_job)];
 //BA.debugLineNum = 17;BA.debugLine="If job.Username <> \"\" And job.Password <> \"\" Then";
if ([_job._username isEqual:@""] == false && [_job._password isEqual:@""] == false) { 
 //BA.debugLineNum = 18;BA.debugLine="hc.ExecuteCredentials(job.GetRequest, taskCounte";
[self._hc ExecuteCredentials:[_job _getrequest] :self._taskcounter :_job._username :_job._password];
 }else {
 //BA.debugLineNum = 20;BA.debugLine="hc.Execute(job.GetRequest, taskCounter)";
[self._hc Execute:[_job _getrequest] :self._taskcounter];
 };
 //BA.debugLineNum = 22;BA.debugLine="End Sub";
return @"";
}
@end
