
#import "b4i_main.h"
#import "b4i_httpjob.h"
#import "b4i_httputils2service.h"
#import "b4i_speakbutton.h"


@implementation b4i_main 


+ (instancetype)new {
    static b4i_main* shared = nil;
    if (shared == nil) {
        shared = [self alloc];
        shared.bi = [[B4I alloc] init:shared];
        shared.__c = [B4ICommon new];
    }
    return shared;
}

- (NSString*)  _activity_create:(BOOL) _firsttime{
 //BA.debugLineNum = 75;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 77;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _application_background{
 //BA.debugLineNum = 80;BA.debugLine="Private Sub Application_Background";
 //BA.debugLineNum = 81;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _application_start:(B4INavigationControllerWrapper*) _nav{
[self initializeStaticModules];
 //BA.debugLineNum = 61;BA.debugLine="Private Sub Application_Start (Nav As NavigationCo";
 //BA.debugLineNum = 62;BA.debugLine="Dim App As Application";
self._app = [B4IApplicationWrapper new];
 //BA.debugLineNum = 63;BA.debugLine="NavControl = Nav";
self._navcontrol = _nav;
 //BA.debugLineNum = 64;BA.debugLine="Page1.Initialize(\"Page1\")";
[self._page1 Initialize:self.bi :@"Page1"];
 //BA.debugLineNum = 65;BA.debugLine="Page1.Title = \"AstroMatch\"";
[self._page1 setTitle:@"AstroMatch"];
 //BA.debugLineNum = 66;BA.debugLine="Page1.RootPanel.Color = Colors.Magenta";
[[self._page1 RootPanel] setColor:[[self.__c Colors] Magenta]];
 //BA.debugLineNum = 67;BA.debugLine="NavControl.ShowPage(Page1)";
[self._navcontrol ShowPage:(UIViewController*)((self._page1).object)];
 //BA.debugLineNum = 68;BA.debugLine="Page1.RootPanel.LoadLayout(\"AstroMatch\")";
[[self._page1 RootPanel] LoadLayout:@"AstroMatch" :self.bi];
 //BA.debugLineNum = 69;BA.debugLine="NavControl.ShowPage(Page1)";
[self._navcontrol ShowPage:(UIViewController*)((self._page1).object)];
 //BA.debugLineNum = 70;BA.debugLine="TTS1.Initialize(\"TTS1\")";
[self._tts1 Initialize:self.bi :@"TTS1"];
 //BA.debugLineNum = 72;BA.debugLine="DateTime.DateFormat = \"MM/dd/yyyy\"";
[[self.__c DateTime] setDateFormat:@"MM/dd/yyyy"];
 //BA.debugLineNum = 73;BA.debugLine="do_sound = \"YES\"";
self._do_sound = @"YES";
 //BA.debugLineNum = 74;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _button10_click{
 //BA.debugLineNum = 96;BA.debugLine="Sub button10_click";
 //BA.debugLineNum = 97;BA.debugLine="NavControl.RemoveCurrentPage";
[self._navcontrol RemoveCurrentPage];
 //BA.debugLineNum = 98;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _button13_click{
 //BA.debugLineNum = 109;BA.debugLine="Sub button13_click";
 //BA.debugLineNum = 110;BA.debugLine="NavControl.RemoveCurrentPage";
[self._navcontrol RemoveCurrentPage];
 //BA.debugLineNum = 111;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _button7_click{
 //BA.debugLineNum = 82;BA.debugLine="Sub button7_click";
 //BA.debugLineNum = 83;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _page1_resize:(int) _width :(int) _height{
 //BA.debugLineNum = 78;BA.debugLine="Private Sub Page1_Resize(Width As Int, Height As I";
 //BA.debugLineNum = 79;BA.debugLine="End Sub";
return @"";
}

- (void)initializeStaticModules {
    [[b4i_main new]initializeModule];
[[b4i_httputils2service new]initializeModule];

}
- (NSString*)  _process_globals{
self._httputils2service=[b4i_httputils2service new];
 //BA.debugLineNum = 11;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 14;BA.debugLine="Public App As Application";
self._app = [B4IApplicationWrapper new];
 //BA.debugLineNum = 15;BA.debugLine="Public NavControl As NavigationController";
self._navcontrol = [B4INavigationControllerWrapper new];
 //BA.debugLineNum = 16;BA.debugLine="Private Page1 As Page";
self._page1 = [B4IPage new];
 //BA.debugLineNum = 17;BA.debugLine="Private Page2 As Page";
self._page2 = [B4IPage new];
 //BA.debugLineNum = 18;BA.debugLine="Private Page3 As Page";
self._page3 = [B4IPage new];
 //BA.debugLineNum = 19;BA.debugLine="Private Page4 As Page";
self._page4 = [B4IPage new];
 //BA.debugLineNum = 20;BA.debugLine="Private Page10 As Page";
self._page10 = [B4IPage new];
 //BA.debugLineNum = 21;BA.debugLine="Private TextField1 As TextField";
self._textfield1 = [B4ITextFieldWrapper new];
 //BA.debugLineNum = 22;BA.debugLine="Private label3 As Label";
self._label3 = [B4ILabelWrapper new];
 //BA.debugLineNum = 23;BA.debugLine="Dim TTS1 As TTS";
self._tts1 = [B4ITTS new];
 //BA.debugLineNum = 24;BA.debugLine="Dim housman As String";
self._housman = @"";
 //BA.debugLineNum = 25;BA.debugLine="Dim pnlPage1, pnlPage2, pnlPage3, pn1Main, pnlPag";
self._pnlpage1 = [B4IPanelWrapper new];
self._pnlpage2 = [B4IPanelWrapper new];
self._pnlpage3 = [B4IPanelWrapper new];
self._pn1main = [B4IPanelWrapper new];
self._pnlpage4 = [B4IPanelWrapper new];
 //BA.debugLineNum = 26;BA.debugLine="Dim job1, job2, job3 As HttpJob";
self._job1 = [b4i_httpjob new];
self._job2 = [b4i_httpjob new];
self._job3 = [b4i_httpjob new];
 //BA.debugLineNum = 27;BA.debugLine="Dim spoken_text As String";
self._spoken_text = @"";
 //BA.debugLineNum = 28;BA.debugLine="Dim spoken_text_2 As String";
self._spoken_text_2 = @"";
 //BA.debugLineNum = 29;BA.debugLine="Dim day1 As String";
self._day1 = @"";
 //BA.debugLineNum = 30;BA.debugLine="Dim month1 As String";
self._month1 = @"";
 //BA.debugLineNum = 31;BA.debugLine="Dim year1 As String";
self._year1 = @"";
 //BA.debugLineNum = 32;BA.debugLine="Dim day2 As String";
self._day2 = @"";
 //BA.debugLineNum = 33;BA.debugLine="Dim month2 As String";
self._month2 = @"";
 //BA.debugLineNum = 34;BA.debugLine="Dim year2 As String";
self._year2 = @"";
 //BA.debugLineNum = 35;BA.debugLine="Dim lable_one As String";
self._lable_one = @"";
 //BA.debugLineNum = 36;BA.debugLine="Private Button13 As Button";
self._button13 = [B4IButtonWrapper new];
 //BA.debugLineNum = 37;BA.debugLine="Private target0 As String";
self._target0 = @"";
 //BA.debugLineNum = 38;BA.debugLine="Private target As String";
self._target = @"";
 //BA.debugLineNum = 39;BA.debugLine="Private target3 As String";
self._target3 = @"";
 //BA.debugLineNum = 40;BA.debugLine="Private offset As Int";
self._offset = 0;
 //BA.debugLineNum = 41;BA.debugLine="Public  date_index As String";
self._date_index = @"";
 //BA.debugLineNum = 42;BA.debugLine="Private Results As Button";
self._results = [B4IButtonWrapper new];
 //BA.debugLineNum = 43;BA.debugLine="Private do_sound As String";
self._do_sound = @"";
 //BA.debugLineNum = 44;BA.debugLine="Public App As Application";
self._app = [B4IApplicationWrapper new];
 //BA.debugLineNum = 45;BA.debugLine="Public NavControl As NavigationController";
self._navcontrol = [B4INavigationControllerWrapper new];
 //BA.debugLineNum = 46;BA.debugLine="Private Page1 As Page";
self._page1 = [B4IPage new];
 //BA.debugLineNum = 47;BA.debugLine="Public const CLIENT_TOKEN As String = \"11fbf04b53";
self._client_token = @"11fbf04b53b2446ea2263376d6cbec88 ";
 //BA.debugLineNum = 48;BA.debugLine="Public const SUBSCRIPTION_KEY As String = \"620335";
self._subscription_key = @"620335e3-3214-4a0e-b43b-ee91e37f22bb";
 //BA.debugLineNum = 50;BA.debugLine="Private Speak As SpeakButton";
self._speak = [b4i_speakbutton new];
 //BA.debugLineNum = 51;BA.debugLine="Private TextView1 As TextView";
self._textview1 = [B4ITextViewWrapper new];
 //BA.debugLineNum = 52;BA.debugLine="Private Panel1 As Panel";
self._panel1 = [B4IPanelWrapper new];
 //BA.debugLineNum = 54;BA.debugLine="Private Label6 As Label";
self._label6 = [B4ILabelWrapper new];
 //BA.debugLineNum = 55;BA.debugLine="Private Speek1 As Label";
self._speek1 = [B4ILabelWrapper new];
 //BA.debugLineNum = 56;BA.debugLine="Private Phone1 As Phone";
self._phone1 = [B4IPhone new];
 //BA.debugLineNum = 57;BA.debugLine="Private MP As MediaPlayer";
self._mp = [B4IMediaPlayer new];
 //BA.debugLineNum = 58;BA.debugLine="Dim App As Application";
self._app = [B4IApplicationWrapper new];
 //BA.debugLineNum = 59;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _results_click{
 //BA.debugLineNum = 84;BA.debugLine="Sub results_click";
 //BA.debugLineNum = 85;BA.debugLine="TTS1.SpeechRate =0.15 'Iphone 5";
[self._tts1 setSpeechRate:(float) (0.15)];
 //BA.debugLineNum = 86;BA.debugLine="offset = 2";
self._offset = (int) (2);
 //BA.debugLineNum = 87;BA.debugLine="spoken_text = \"These two have Compatibility ...";
self._spoken_text = @"These two have Compatibility ... Scores of...";
 //BA.debugLineNum = 88;BA.debugLine="TTS1.Speak(spoken_text, False)";
[self._tts1 Speak:self._spoken_text :[self.__c False]];
 //BA.debugLineNum = 89;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _speak_result:(BOOL) _success :(NSString*) _resolved{
 //BA.debugLineNum = 113;BA.debugLine="public Sub Speak_Result(Success As Boolean, Resolv";
 //BA.debugLineNum = 114;BA.debugLine="If Success Then";
if (_success) { 
 //BA.debugLineNum = 115;BA.debugLine="TextView1.Text = $\"Resolved: ${Resolved}\"$";
[self._textview1 setText:([@[@"Resolved: ",[self.__c SmartStringFormatter:@"" :(NSObject*)(_resolved)],@""] componentsJoinedByString:@""])];
 }else {
 //BA.debugLineNum = 117;BA.debugLine="TextView1.Text = $\"Error: ${Resolved}\"$";
[self._textview1 setText:([@[@"Error: ",[self.__c SmartStringFormatter:@"" :(NSObject*)(_resolved)],@""] componentsJoinedByString:@""])];
 };
 //BA.debugLineNum = 119;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _speek1_click{
 //BA.debugLineNum = 100;BA.debugLine="Sub Speek1_click";
 //BA.debugLineNum = 101;BA.debugLine="date_index = 1";
self._date_index = [self.bi NumberToString:@(1)];
 //BA.debugLineNum = 102;BA.debugLine="Page10.Initialize(\"Page10\")";
[self._page10 Initialize:self.bi :@"Page10"];
 //BA.debugLineNum = 103;BA.debugLine="Page10.RootPanel.LoadLayout(\"Main\")";
[[self._page10 RootPanel] LoadLayout:@"Main" :self.bi];
 //BA.debugLineNum = 104;BA.debugLine="NavControl.ShowPage(Page10)";
[self._navcontrol ShowPage:(UIViewController*)((self._page10).object)];
 //BA.debugLineNum = 105;BA.debugLine="Speak.Initialize(Me, \"speak\")";
[self._speak _initialize:self.bi :self :@"speak"];
 //BA.debugLineNum = 106;BA.debugLine="Speak.AddToPanel(Panel1)";
[self._speak _addtopanel:self._panel1];
 //BA.debugLineNum = 107;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _tts1_ready:(BOOL) _success{
 //BA.debugLineNum = 90;BA.debugLine="Sub TTS1_Ready (Success As Boolean)";
 //BA.debugLineNum = 91;BA.debugLine="If Success Then";
if (_success) { 
 }else {
 //BA.debugLineNum = 93;BA.debugLine="Msgbox(\"Error initializing TTS engine.\", \"\")";
[self.__c Msgbox:@"Error initializing TTS engine." :@""];
 };
 //BA.debugLineNum = 95;BA.debugLine="End Sub";
return @"";
}
@end
