
#import "b4i_speakbutton.h"
#import "b4i_main.h"
#import "b4i_httpjob.h"
#import "b4i_httputils2service.h"


@implementation b4i_speakbutton 


+ (B4I*)createBI {
    return [B4I alloc];
}

- (void)dealloc {
    if (self.bi != nil)
        NSLog(@"Class (b4i_speakbutton) instance released.");
}
- (NSString*)  _addtopanel:(B4IPanelWrapper*) _pnl{
 //BA.debugLineNum = 22;BA.debugLine="public Sub AddToPanel(pnl As Panel)";
 //BA.debugLineNum = 23;BA.debugLine="pnl.LoadLayout(\"SpeakButton\")";
[_pnl LoadLayout:@"SpeakButton" :self.bi];
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _basepanel_touch:(int) _action :(float) _x :(float) _y{
b4i_httpjob* _j = nil;
B4IJSONGenerator* _jg = nil;
_multipartfiledata* _fd = nil;
 //BA.debugLineNum = 25;BA.debugLine="private Sub BasePanel_Touch(Action As Int, X As Fl";
 //BA.debugLineNum = 26;BA.debugLine="If Action = basePanel.ACTION_DOWN Then";
if (_action==[self._basepanel ACTION_DOWN]) { 
 //BA.debugLineNum = 27;BA.debugLine="ar.Record";
[self._ar Record];
 //BA.debugLineNum = 28;BA.debugLine="basePanel.Color = Colors.Green";
[self._basepanel setColor:[[self.__c Colors] Green]];
 //BA.debugLineNum = 29;BA.debugLine="ActivityIndicator1.Visible = False";
[self._activityindicator1 setVisible:[self.__c False]];
 }else if(_action==[self._basepanel ACTION_UP]) { 
 //BA.debugLineNum = 31;BA.debugLine="basePanel.Color = Colors.Transparent";
[self._basepanel setColor:[[self.__c Colors] Transparent]];
 //BA.debugLineNum = 32;BA.debugLine="ActivityIndicator1.Visible = True";
[self._activityindicator1 setVisible:[self.__c True]];
 //BA.debugLineNum = 33;BA.debugLine="lblHoldToRecord.Visible = False";
[self._lblholdtorecord setVisible:[self.__c False]];
 //BA.debugLineNum = 34;BA.debugLine="ar.Stop";
[self._ar Stop];
 //BA.debugLineNum = 35;BA.debugLine="Dim j As HttpJob";
_j = [b4i_httpjob new];
 //BA.debugLineNum = 36;BA.debugLine="j.Initialize(\"j\", Me)";
[_j _initialize:self.bi :@"j" :self];
 //BA.debugLineNum = 37;BA.debugLine="Dim jg As JSONGenerator";
_jg = [B4IJSONGenerator new];
 //BA.debugLineNum = 38;BA.debugLine="jg.Initialize(CreateMap(\"v\": \"20150415\", \"lang\":";
[_jg Initialize:[self.__c createMap:@[(NSObject*)(@"v"),(NSObject*)(@"20150415"),(NSObject*)(@"lang"),(NSObject*)(@"en"),(NSObject*)(@"sessionId"),(NSObject*)(self._sessionid)]]];
 //BA.debugLineNum = 39;BA.debugLine="Dim fd As MultipartFileData";
_fd = [_multipartfiledata new];
 //BA.debugLineNum = 40;BA.debugLine="fd.ContentType = \"audio/wav\"";
_fd.ContentType = @"audio/wav";
 //BA.debugLineNum = 41;BA.debugLine="fd.Dir = File.DirTemp";
_fd.Dir = [[self.__c File] DirTemp];
 //BA.debugLineNum = 42;BA.debugLine="fd.FileName = \"1.wav\"";
_fd.FileName = @"1.wav";
 //BA.debugLineNum = 43;BA.debugLine="fd.KeyName = \"voiceData\" '+\"@sys.date\"";
_fd.KeyName = @"voiceData";
 //BA.debugLineNum = 44;BA.debugLine="j.PostMultipart(\"https://api.api.ai/v1/query\", C";
[_j _postmultipart:@"https://api.api.ai/v1/query" :[self.__c createMap:@[(NSObject*)(@"request"),(NSObject*)([_jg ToString])]] :[self.bi ArrayToList:[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:(NSObject*)(_fd)]]]]];
 //BA.debugLineNum = 45;BA.debugLine="j.GetRequest.SetHeader(\"Authorization\", $\"Bearer";
[[_j _getrequest] SetHeader:@"Authorization" :([@[@"Bearer ",[self.__c SmartStringFormatter:@"" :(NSObject*)(self._main._client_token)],@""] componentsJoinedByString:@""])];
 //BA.debugLineNum = 46;BA.debugLine="j.GetRequest.SetHeader(\"ocp-apim-subscription-ke";
[[_j _getrequest] SetHeader:@"ocp-apim-subscription-key" :self._main._subscription_key];
 };
 //BA.debugLineNum = 48;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _class_globals{
self._main=[b4i_main new];
self._httputils2service=[b4i_httputils2service new];
 //BA.debugLineNum = 2;BA.debugLine="Sub Class_Globals";
 //BA.debugLineNum = 3;BA.debugLine="Private basePanel As Panel";
self._basepanel = [B4IPanelWrapper new];
 //BA.debugLineNum = 4;BA.debugLine="Private ActivityIndicator1 As ActivityIndicator";
self._activityindicator1 = [B4IActivityIndicatorWrapper new];
 //BA.debugLineNum = 5;BA.debugLine="Private lblHoldToRecord As Label";
self._lblholdtorecord = [B4ILabelWrapper new];
 //BA.debugLineNum = 6;BA.debugLine="Private ar As AudioRecorder";
self._ar = [B4IAudioRecorder new];
 //BA.debugLineNum = 7;BA.debugLine="Private sessionId As String";
self._sessionid = @"";
 //BA.debugLineNum = 8;BA.debugLine="Private mEventName As String";
self._meventname = @"";
 //BA.debugLineNum = 9;BA.debugLine="Private mTarget As Object";
self._mtarget = [NSObject new];
 //BA.debugLineNum = 10;BA.debugLine="Private NewDate As String";
self._newdate = @"";
 //BA.debugLineNum = 11;BA.debugLine="Private year As String";
self._year = @"";
 //BA.debugLineNum = 12;BA.debugLine="Private day As String";
self._day = @"";
 //BA.debugLineNum = 13;BA.debugLine="Private month As String";
self._month = @"";
 //BA.debugLineNum = 15;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _initialize:(B4I*) _ba :(NSObject*) _targetmodule :(NSString*) _eventname{
[self initializeClassModule];
 //BA.debugLineNum = 16;BA.debugLine="Public Sub Initialize (TargetModule As Object, Eve";
 //BA.debugLineNum = 17;BA.debugLine="ar.Initialize(File.DirTemp, \"1.wav\", 16000, True,";
[self._ar Initialize:[[self.__c File] DirTemp] :@"1.wav" :(int) (16000) :[self.__c True] :(int) (16) :[self.__c False]];
 //BA.debugLineNum = 18;BA.debugLine="sessionId = Rnd(1000000, 9999999)";
self._sessionid = [self.bi NumberToString:@([self.__c Rnd:(int) (1000000) :(int) (9999999)])];
 //BA.debugLineNum = 19;BA.debugLine="mTarget = TargetModule";
self._mtarget = _targetmodule;
 //BA.debugLineNum = 20;BA.debugLine="mEventName = EventName";
self._meventname = _eventname;
 //BA.debugLineNum = 21;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _jobdone:(b4i_httpjob*) _job{
B4IJSONParser* _jp = nil;
B4IMap* _result = nil;
NSString* _resolvedquery = @"";
B4IJSONParser* _parser = nil;
B4IMap* _jsonmap = nil;
NSString* _date = @"";
B4IArray* _adata = nil;
 //BA.debugLineNum = 49;BA.debugLine="Sub JobDone(job As HttpJob)";
 //BA.debugLineNum = 50;BA.debugLine="ActivityIndicator1.Visible = False";
[self._activityindicator1 setVisible:[self.__c False]];
 //BA.debugLineNum = 51;BA.debugLine="lblHoldToRecord.Visible = True";
[self._lblholdtorecord setVisible:[self.__c True]];
 //BA.debugLineNum = 52;BA.debugLine="If job.Success Then";
if (_job._success) { 
 //BA.debugLineNum = 53;BA.debugLine="Dim jp As JSONParser";
_jp = [B4IJSONParser new];
 //BA.debugLineNum = 54;BA.debugLine="jp.Initialize(job.GetString)";
[_jp Initialize:[_job _getstring]];
 //BA.debugLineNum = 55;BA.debugLine="Log(job.GetString)";
[self.__c Log:[_job _getstring]];
 //BA.debugLineNum = 56;BA.debugLine="Dim result As Map = jp.NextObject.Get(\"result\")";
_result = (B4IMap*)([[_jp NextObject] Get:(NSObject*)(@"result")]);
 //BA.debugLineNum = 57;BA.debugLine="Dim resolvedQuery As String = result.Get(\"resolv";
_resolvedquery = [self.bi ObjectToString:[_result Get:(NSObject*)(@"resolvedQuery")]];
 //BA.debugLineNum = 58;BA.debugLine="Dim Parser As JSONParser";
_parser = [B4IJSONParser new];
 //BA.debugLineNum = 59;BA.debugLine="Dim JSONMap As Map";
_jsonmap = [B4IMap new];
 //BA.debugLineNum = 60;BA.debugLine="Parser.Initialize(job.GetString)";
[_parser Initialize:[_job _getstring]];
 //BA.debugLineNum = 61;BA.debugLine="JSONMap = Parser.NextObject";
_jsonmap = [_parser NextObject];
 //BA.debugLineNum = 62;BA.debugLine="JSONMap = JSONMap.Get(\"result\")";
_jsonmap = (B4IMap*)([_jsonmap Get:(NSObject*)(@"result")]);
 //BA.debugLineNum = 64;BA.debugLine="JSONMap = JSONMap.Get(\"parameters\")";
_jsonmap = (B4IMap*)([_jsonmap Get:(NSObject*)(@"parameters")]);
 //BA.debugLineNum = 65;BA.debugLine="Dim date As String = JSONMap.Get(\"date\")";
_date = [self.bi ObjectToString:[_jsonmap Get:(NSObject*)(@"date")]];
 //BA.debugLineNum = 66;BA.debugLine="Dim adata() As String";
_adata = [[B4IArray alloc]initObjects:@[@((int) (0))] :@"" :nil];
 //BA.debugLineNum = 67;BA.debugLine="adata = Regex.Split(\"-\",date)";
_adata = [[self.__c Regex] Split:@"-" :_date];
 //BA.debugLineNum = 70;BA.debugLine="year = adata(0): month = adata(1): day=adata(2)";
self._year = ((NSString*)[_adata getObjectFast:(int) (0)]);
 //BA.debugLineNum = 70;BA.debugLine="year = adata(0): month = adata(1): day=adata(2)";
self._month = ((NSString*)[_adata getObjectFast:(int) (1)]);
 //BA.debugLineNum = 70;BA.debugLine="year = adata(0): month = adata(1): day=adata(2)";
self._day = ((NSString*)[_adata getObjectFast:(int) (2)]);
 //BA.debugLineNum = 71;BA.debugLine="NewDate = month & \"/\" & day & \"/\" & year";
self._newdate = [@[self._month,@"/",self._day,@"/",self._year] componentsJoinedByString:@""];
 //BA.debugLineNum = 72;BA.debugLine="Msgbox (\"NewDate=\" & NewDate,\"\")";
[self.__c Msgbox:[@[@"NewDate=",self._newdate] componentsJoinedByString:@""] :@""];
 //BA.debugLineNum = 75;BA.debugLine="CallSub3(mTarget, mEventName & \"_result\", True,";
[self.__c CallSub3:self.bi :self._mtarget :[@[self._meventname,@"_result"] componentsJoinedByString:@""] :(NSObject*)(@([self.__c True])) :(NSObject*)(_resolvedquery)];
 }else {
 //BA.debugLineNum = 77;BA.debugLine="CallSub3(mTarget, mEventName & \"_result\", False,";
[self.__c CallSub3:self.bi :self._mtarget :[@[self._meventname,@"_result"] componentsJoinedByString:@""] :(NSObject*)(@([self.__c False])) :(NSObject*)(_job._errormessage)];
 };
 //BA.debugLineNum = 79;BA.debugLine="job.Release";
[_job _release];
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return @"";
}
@end
